// -*- mode: c++; c-indent-level: 4; c++-member-init-indent: 8; comment-column: 35; -*-

#ifndef __FuncQAP
#define __FuncQAP

#include <eo>
#include <ga.h>

template< class EOT >
class FuncQAP : public eoEvalFunc<EOT>
{
  // nombre de variable
  unsigned n;
    
  // site
  unsigned ** sites;

  // unites
  unsigned ** units;

public:
  FuncQAP(const char * fileData) {
    fstream file(fileData, ios::in);
    unsigned i, j;

    if (file.is_open()) {
      file >> n;
      sites = new unsigned *[n];
      units = new unsigned *[n];

      for(i = 0; i < n; i++) {
	sites[i] = new unsigned[n];
	for(j = 0; j < n; j++) {
	  file >> sites[i][j];
	}
      }

      for(i = 0; i < n; i++) {
	units[i] = new unsigned[n];
	for(j = 0; j < n; j++) 
	  file >> units[i][j];
      }
      
      file.close();
    } else
      cerr <<"FuncQap: impossible to open " << fileData << endl;
  };

  ~FuncQAP(void) {
    unsigned i;

    if (sites != NULL) {
      for(i = 0; i < n; i++) 
	delete[] sites[i];
      delete[] sites;
    }

    if (units != NULL) {
      for(i = 0; i < n; i++) 
	delete[] units[i];
      delete[] units;
    }
  } ;
    
  virtual void operator() (EOT & _chrom)
  {
    double sum = 0;
    unsigned i, j;

    for(i = 0; i < n; i++) {
      for(j = 0; j < n;j++)
	sum += units[i][j] * sites[_chrom[i]][_chrom[j]];
    }

    _chrom.fitness(-sum);
  };
    
};


#endif
