#ifndef __initPerm
#define __initPerm

/**
 *   Initializer for fixed length representations with a single type
**/

template <class EOT>
class PermInit: public eoInit<EOT>
{
public:

  typedef typename EOT::Fitness Fitness;

  PermInit(unsigned _combien)
    : combien(_combien) {}

  virtual void operator()(EOT& chrom)
  {
    Perm<Fitness> & genome = (Perm<Fitness> &) chrom;
    genome.resize(combien);

    unsigned i;
    for(i = 0; i < combien; i++)
      genome[i] = i;

    unsigned n;
    unsigned temp;
    for(i = 0; i < combien - 1; i++) {
      n = i + rng.random(combien - i);
      temp      = genome[n];
      genome[n] = genome[i];
      genome[i] = temp;
    }
    
    genome.invalidate();
  }

private :
  unsigned combien;

};

#endif
