// -*- mode: c++; c-indent-level: 4; c++-member-init-indent: 8; comment-column: 35; -*-

#ifndef __permut
#define __permut

//-----------------------------------------------------------------------------

#include <iostream>    // ostream, istream
#include <functional>  // bind2nd
#include <string>      // string

#include <eoVector.h>

/**

/** permut: implementation of permut chromosome.
  * based on STL's vector<unsigned> specialization.
*/
template <class FitT> class Perm: public eoVector<FitT, unsigned>
{
 public:

  /**
   * (Default) Constructor.
   * @param size Size of the permut string.
   */
  Perm(unsigned size = 0, unsigned value = 0):
    eoVector<FitT, unsigned>(size, value) {}

  /// My class name.
  virtual std::string className() const
    {
      return "Perm";
    }

    /// printing...
    virtual void printOn(ostream& os) const
    {
        EO<FitT>::printOn(os);
        os << ' ';

        os << this->size() << ' ';

        std::copy(this->begin(), this->end(), ostream_iterator<unsigned>(os, " "));
    }

  /**
   * To read me from a stream.
   * @param is The istream.
   */
  virtual void readFrom(istream& is)
    {
    }
};

//-----------------------------------------------------------------------------

#endif //permut_h
